/**
\mainpage

\section intro_hppDynamicObstacle INTRODUCTION

This package implements Roadmap managment based on modification in environments. It will decompose an allocated volume of environment to 3D cells which their size is chosen by user. Then, a   list of nodes and edges are associated to each cell. In case of adding a new obstacle to the environment or obstacle displacement,  the list of nodes and edges which related to the modified cells are validated. The non-valid edges and node will be removed from the roadmap. The modified roadmap will be used in the next motion planning. Using this roadmap manager will prevent erasing the roadmap after each update in the environment and will keep the information of generated graph in the workspace.

\image html "./pictures/algo.png" "Example of a roadmap managment."

\section HOW How TO USE THIS PACKAGE:
For using the package, create a ChppDynamicEnvHandler object and initialize the object as follow:

\li ChppDynamicEnvHandler::allocateMap ( double xstart, double ystart, double zstart,double xend, double yend, double zend ) to set the size of environemnt.
\li ChppDynamicEnvHandler::setCellSize( double inCellSize ) to set the size of cells.
\li ChppDynamicEnvHandler::setRoadmap ( CkwsPlusRoadmapShPtr inRoadmap ) to set the roadmap which will be modified.

A set of hppDynamicObstacleKCD and hppDynamicObstacleOccupancyMap can be added to the environment by 

\li ChppDynamicEnvHandler::addObstacle(ChppDynamicObstacleShPtr inObstacle)

In case of entering a new hppDynamicObstacleKCD  in the environment or displacing the obstacle or in case of modification in hppDynamicObstacleOccupancyMap, by calling:
ChppDynamicEnvHandler::updateRoadmap(),  attRoadmap will be modified. 

*/

